#include <Application.h>
#include <InterfaceKit.h> 
#include <StorageKit.h>


#include <be/add-ons/tracker/TrackerAddon.h>
#include </boot/home/config/include/mhash.h>

//#include <iostream>
#include <stdio.h>

using namespace std;

int file_hash(const char *, BTextView *view);



void process_refs(entry_ref dir_ref, BMessage *msg, void *)
{
	BWindow *window = new BWindow(BRect(100,100,550,200), 
      	"HashBrown Add-on", B_TITLED_WINDOW, 0);
    BTextView *view = new BTextView(BRect(0,0,450,100), "view",
      	BRect(0,0,450,100), B_FOLLOW_ALL_SIDES, B_WILL_DRAW |
      	B_FULL_UPDATE_ON_RESIZE);
      	
	BPath path;
	BEntry entry(&dir_ref);
	entry.GetPath(&path);
//	view->Insert("Current Directory: \n");
//	view->Insert(path.Path());
//	view->Insert("\n\n");
      
      
    int refs;
	entry_ref file_ref;

	for (refs=0;msg->FindRef("refs", refs, &file_ref) == B_NO_ERROR;refs++) 
	{
		if (refs == 0) //CRC32:\t
			view->Insert("MD5Sum:\t\t\t\t\t\tSelected files:\n");
		entry.SetTo(&file_ref);
		entry.GetPath(&path);
		
		
		/****************************
		 * Test of the mhash library
		 ****************************/
		file_hash(path.Path(), view);

		view->Insert("\t");
		view->Insert(path.Path());
		view->Insert("\n");
	}
	
     
    //view->Insert("Hello World!\n\n");

    window->AddChild(view);
    window->Show();
}

int file_hash(const char * file_name, BTextView *view)
{

    // read a file
    FILE			*fptr;
   	unsigned char	buffer[64];
	unsigned char	hash[16];
	MHASH			td;
	
	/*
	unsigned char	buffer2[64];
	unsigned char	hash2[16];
	MHASH			td2;
	*/
	td	= mhash_init(MHASH_MD5);
	
	if (td == MHASH_FAILED)
		return 1;
	/*
	td2	= mhash_init(MHASH_CRC32);
	
	if (td2 == MHASH_FAILED)
		return 2;
	*/	
	if ((fptr = fopen(file_name, "r")) != NULL)
	{
		
	    //* **Works**
	    // reset the file pointer to the start of the file
	    fseek(fptr, 0, SEEK_SET);
	    
	    size_t r; //how much was read
	    
	    // read in the entire file
	    while ((r = fread(&buffer, 1, 64, fptr)) >= 1) { 
	    	// create the hash
			mhash(td, &buffer, r); 
	    } 
	    // */
	    
		mhash_deinit(td, hash);

		// print the hash
	   	char *p; char s; p = &s;
	    for (unsigned int i = 0; i < mhash_get_block_size(MHASH_MD5); i++) {
	    	if (i == 0)
	    		sprintf(&s, "%.2x", hash[i]);
	    	sprintf(p, "%.2x", hash[i]);
	    	view->Insert(p); 
	    }
	    
		//view->Insert("\t");

		/* **** Start CRC32 ****
		// reset the file pointer to the start of the file
	    fseek(fptr, 0, SEEK_SET);
	    r = 0;
	    
	    // read in the entire file
	    while ((r = fread(&buffer2, 1, 1, fptr)) >= 1) { 
	    	// create the hash
			mhash(td2, &buffer2, r); 
	    }
	    
		mhash_deinit(td2, hash2);
		// */
		/*
		// print the hash
	   	char *t; char u; t = &u; char z[8];
	    for (unsigned int i = 0; i < mhash_get_block_size(MHASH_CRC32); i++) {
	    	if (i == 0)
	    		sprintf(&u, "%.2x", hash2[i]);
	    	sprintf(t, "%.2x", hash2[i]);
	    	view->Insert(t); 
	    }
	    sprintf(z, "%.2x", hash2);
	    view->Insert(z);
	    // */
	}    
	return 0;    

}



int main()
{
	/************************************
	 * Show a message in case this is 
	 * executed as a regular application
	 ************************************/
	new BApplication("application/x-hashbrown-add-on");
	(new BAlert("", "HashBrown Add-on", "Ok"))->Go();
/*	
	BWindow *window = new BWindow(BRect(100,100,300,300), 
      	"HashBrown Add-on", B_TITLED_WINDOW, 0);
    BTextView *view = new BTextView(BRect(0,0,200,200), "view",
      	BRect(0,0,200,200), B_FOLLOW_ALL_SIDES, B_WILL_DRAW |
      	B_FULL_UPDATE_ON_RESIZE);
	if (file_hash("/boot/home/screen1.tga", view) == 1)
		return 1;
*/

	delete be_app;
	return 0;
}